
#include <os.h>
#include "utils.h"
#include "stringHelper.h"

int main(void)
{
	char *scrbuf = (char*)malloc(SCREEN_BYTES_SIZE);
	memset(scrbuf, 0xFF, SCREEN_BYTES_SIZE);			// Clears crap out of buffer

	char output[50];
	memset(output, 0, 50);
	int textIndex = -1;

	int ctrlOn = -1;
	int textColor = 0;
	int backColor = 15;

	drawString2("The text you are currently reading is in a 16 pt. Ubuntu", 10, 150, 0, 15, scrbuf);
	drawString2("Light font. After rasterizing the font with a program I", 10, 166, 0, 15, scrbuf);
	drawString2("found online, I wrote a program in C# to convert the .bmp", 10, 182, 0, 15, scrbuf);
	drawString2("into raw pixel data and to measure the character spacing.", 10, 198, 0, 15, scrbuf);
	drawString2("Currently, ascii characters 32-117 are supported." 10, 212, 0, 15, scrbuf);

	refresh(scrbuf);

	// Stops when escape is pressed
	while(1)
	{
		idle();
		if (any_key_pressed())
		{
			if (isKeyPressed(KEY_NSPIRE_CTRL))
			{
				ctrlOn = ctrlOn * -1;
				textIndex--;
			}

			if (isKeyPressed(KEY_NSPIRE_ESC))
				break;

			if (isKeyPressed(KEY_NSPIRE_0))
				output[textIndex] = '0';
			if (isKeyPressed(KEY_NSPIRE_1))
				output[textIndex] = '1';
			if (isKeyPressed(KEY_NSPIRE_2))
				output[textIndex] = '2';
			if (isKeyPressed(KEY_NSPIRE_3))
				output[textIndex] = '3';
			if (isKeyPressed(KEY_NSPIRE_4))
				output[textIndex] = '4';
			if (isKeyPressed(KEY_NSPIRE_5))
				output[textIndex] = '5';
			if (isKeyPressed(KEY_NSPIRE_6))
				output[textIndex] = '6';
			if (isKeyPressed(KEY_NSPIRE_7))
				output[textIndex] = '7';
			if (isKeyPressed(KEY_NSPIRE_8))
				output[textIndex] = '8';
			if (isKeyPressed(KEY_NSPIRE_9))
				output[textIndex] = '9';
			if(isKeyPressed(KEY_NSPIRE_SPACE))
				output[textIndex] = ' ';

			if(isKeyPressed(KEY_NSPIRE_PLUS))
			{
				if(textColor != 0)
					textColor--;
				textIndex--;
			}
			if(isKeyPressed(KEY_NSPIRE_MINUS))
			{
				if (textColor != 15)
					textColor++;
				textIndex--;
			}
			if(isKeyPressed(KEY_NSPIRE_MULTIPLY))
			{
				if (backColor != 0)
					backColor--;
				textIndex--;
			}
			if(isKeyPressed(KEY_NSPIRE_DIVIDE))
			{
				if (backColor != 15)
					backColor++;
				textIndex--;
			}

			if (ctrlOn == 1)
			{
				if (isKeyPressed(KEY_NSPIRE_A))
					output[textIndex] = 'A';
				if (isKeyPressed(KEY_NSPIRE_B))
					output[textIndex] = 'B';
				if (isKeyPressed(KEY_NSPIRE_C))
					output[textIndex] = 'C';
				if (isKeyPressed(KEY_NSPIRE_D))
					output[textIndex] = 'D';
				if (isKeyPressed(KEY_NSPIRE_E))
					output[textIndex] = 'E';
				if (isKeyPressed(KEY_NSPIRE_F))
					output[textIndex] = 'F';
				if (isKeyPressed(KEY_NSPIRE_G))
					output[textIndex] = 'G';
				if (isKeyPressed(KEY_NSPIRE_H))
					output[textIndex] = 'H';
				if (isKeyPressed(KEY_NSPIRE_I))
					output[textIndex] = 'I';
				if (isKeyPressed(KEY_NSPIRE_J))
					output[textIndex] = 'J';
				if (isKeyPressed(KEY_NSPIRE_K))
					output[textIndex] = 'K';
				if (isKeyPressed(KEY_NSPIRE_L))
					output[textIndex] = 'L';
				if (isKeyPressed(KEY_NSPIRE_M))
					output[textIndex] = 'M';
				if (isKeyPressed(KEY_NSPIRE_N))
					output[textIndex] = 'N';
				if (isKeyPressed(KEY_NSPIRE_O))
					output[textIndex] = 'O';
				if (isKeyPressed(KEY_NSPIRE_P))
					output[textIndex] = 'P';
				if (isKeyPressed(KEY_NSPIRE_Q))
					output[textIndex] = 'Q';
				if (isKeyPressed(KEY_NSPIRE_R))
					output[textIndex] = 'R';
				if (isKeyPressed(KEY_NSPIRE_S))
					output[textIndex] = 'S';
				if (isKeyPressed(KEY_NSPIRE_T))
					output[textIndex] = 'T';
				if (isKeyPressed(KEY_NSPIRE_U))
					output[textIndex] = 'U';
				if (isKeyPressed(KEY_NSPIRE_V))
					output[textIndex] = 'V';
				if (isKeyPressed(KEY_NSPIRE_W))
					output[textIndex] = 'W';
				if (isKeyPressed(KEY_NSPIRE_X))
					output[textIndex] = 'X';
				if (isKeyPressed(KEY_NSPIRE_Y))
					output[textIndex] = 'Y';
				if (isKeyPressed(KEY_NSPIRE_Z))
					output[textIndex] = 'Z';
			}
			else
			{
				if (isKeyPressed(KEY_NSPIRE_A))
					output[textIndex] = 'a';
				if (isKeyPressed(KEY_NSPIRE_B))
					output[textIndex] = 'b';
				if (isKeyPressed(KEY_NSPIRE_C))
					output[textIndex] = 'c';
				if (isKeyPressed(KEY_NSPIRE_D))
					output[textIndex] = 'd';
				if (isKeyPressed(KEY_NSPIRE_E))
					output[textIndex] = 'e';
				if (isKeyPressed(KEY_NSPIRE_F))
					output[textIndex] = 'f';
				if (isKeyPressed(KEY_NSPIRE_G))
					output[textIndex] = 'g';
				if (isKeyPressed(KEY_NSPIRE_H))
					output[textIndex] = 'h';
				if (isKeyPressed(KEY_NSPIRE_I))
					output[textIndex] = 'i';
				if (isKeyPressed(KEY_NSPIRE_J))
					output[textIndex] = 'j';
				if (isKeyPressed(KEY_NSPIRE_K))
					output[textIndex] = 'k';
				if (isKeyPressed(KEY_NSPIRE_L))
					output[textIndex] = 'l';
				if (isKeyPressed(KEY_NSPIRE_M))
					output[textIndex] = 'm';
				if (isKeyPressed(KEY_NSPIRE_N))
					output[textIndex] = 'n';
				if (isKeyPressed(KEY_NSPIRE_O))
					output[textIndex] = 'o';
				if (isKeyPressed(KEY_NSPIRE_P))
					output[textIndex] = 'p';
				if (isKeyPressed(KEY_NSPIRE_Q))
					output[textIndex] = 'q';
				if (isKeyPressed(KEY_NSPIRE_R))
					output[textIndex] = 'r';
				if (isKeyPressed(KEY_NSPIRE_S))
					output[textIndex] = 's';
				if (isKeyPressed(KEY_NSPIRE_T))
					output[textIndex] = 't';
				if (isKeyPressed(KEY_NSPIRE_U))
					output[textIndex] = 'u';
				if (isKeyPressed(KEY_NSPIRE_V))
					output[textIndex] = 'v';
				if (isKeyPressed(KEY_NSPIRE_W))
					output[textIndex] = 'w';
				if (isKeyPressed(KEY_NSPIRE_X))
					output[textIndex] = 'x';
				if (isKeyPressed(KEY_NSPIRE_Y))
					output[textIndex] = 'y';
				if (isKeyPressed(KEY_NSPIRE_Z))
					output[textIndex] = 'z';
			}

			textIndex++;

			wait_no_key_pressed();
			drawString2(output, 10, 10, textColor, backColor, scrbuf);
			refresh(scrbuf);
		}
	}

	free(scrbuf);
	return 0;
}
